/**************************************************************************************************
*                                                                                                 *
* This file is part of HPMPC.                                                                     *
*                                                                                                 *
* HPMPC -- Library for High-Performance implementation of solvers for MPC.                        *
* Copyright (C) 2014-2015 by Technical University of Denmark. All rights reserved.                *
*                                                                                                 *
* HPMPC is free software; you can redistribute it and/or                                          *
* modify it under the terms of the GNU Lesser General Public                                      *
* License as published by the Free Software Foundation; either                                    *
* version 2.1 of the License, or (at your option) any later version.                              *
*                                                                                                 *
* HPMPC is distributed in the hope that it will be useful,                                        *
* but WITHOUT ANY WARRANTY; without even the implied warranty of                                  *
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.                                            *
* See the GNU Lesser General Public License for more details.                                     *
*                                                                                                 *
* You should have received a copy of the GNU Lesser General Public                                *
* License along with HPMPC; if not, write to the Free Software                                    *
* Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA                  *
*                                                                                                 *
* Author: Gianluca Frison, giaf (at) dtu.dk                                                       *
*                                                                                                 *
**************************************************************************************************/



void kernel_strmv_u_t_8_lib8(int kmax, float *A, int sda, float *x, float *y, int alg)
	{

/*	if(kmax<=0) */
/*		return;*/
	
	const int lda = 8;
	const int bs  = 8;
	
	int
		k;
	
	float
		x_0, x_1, x_2, x_3,
		y_0=0, y_1=0, y_2=0, y_3=0,
		y_4=0, y_5=0, y_6=0, y_7=0;
	
	k=0;
	for(; k<kmax-7; k+=8)
		{
		
		x_0 = x[0];
		x_1 = x[1];
		x_2 = x[2];
		x_3 = x[3];
		
		y_0 += A[0+lda*0] * x_0;
		y_1 += A[0+lda*1] * x_0;
		y_2 += A[0+lda*2] * x_0;
		y_3 += A[0+lda*3] * x_0;
		y_4 += A[0+lda*4] * x_0;
		y_5 += A[0+lda*5] * x_0;
		y_6 += A[0+lda*6] * x_0;
		y_7 += A[0+lda*7] * x_0;

		y_0 += A[1+lda*0] * x_1;
		y_1 += A[1+lda*1] * x_1;
		y_2 += A[1+lda*2] * x_1;
		y_3 += A[1+lda*3] * x_1;
		y_4 += A[1+lda*4] * x_1;
		y_5 += A[1+lda*5] * x_1;
		y_6 += A[1+lda*6] * x_1;
		y_7 += A[1+lda*7] * x_1;
		
		y_0 += A[2+lda*0] * x_2;
		y_1 += A[2+lda*1] * x_2;
		y_2 += A[2+lda*2] * x_2;
		y_3 += A[2+lda*3] * x_2;
		y_4 += A[2+lda*4] * x_2;
		y_5 += A[2+lda*5] * x_2;
		y_6 += A[2+lda*6] * x_2;
		y_7 += A[2+lda*7] * x_2;

		y_0 += A[3+lda*0] * x_3;
		y_1 += A[3+lda*1] * x_3;
		y_2 += A[3+lda*2] * x_3;
		y_3 += A[3+lda*3] * x_3;
		y_4 += A[3+lda*4] * x_3;
		y_5 += A[3+lda*5] * x_3;
		y_6 += A[3+lda*6] * x_3;
		y_7 += A[3+lda*7] * x_3;
		
/*		A += sda*bs;*/
/*		x += 4;*/

		x_0 = x[4];
		x_1 = x[5];
		x_2 = x[6];
		x_3 = x[7];
		
		y_0 += A[4+lda*0] * x_0;
		y_1 += A[4+lda*1] * x_0;
		y_2 += A[4+lda*2] * x_0;
		y_3 += A[4+lda*3] * x_0;
		y_4 += A[4+lda*4] * x_0;
		y_5 += A[4+lda*5] * x_0;
		y_6 += A[4+lda*6] * x_0;
		y_7 += A[4+lda*7] * x_0;

		y_0 += A[5+lda*0] * x_1;
		y_1 += A[5+lda*1] * x_1;
		y_2 += A[5+lda*2] * x_1;
		y_3 += A[5+lda*3] * x_1;
		y_4 += A[5+lda*4] * x_1;
		y_5 += A[5+lda*5] * x_1;
		y_6 += A[5+lda*6] * x_1;
		y_7 += A[5+lda*7] * x_1;
		
		y_0 += A[6+lda*0] * x_2;
		y_1 += A[6+lda*1] * x_2;
		y_2 += A[6+lda*2] * x_2;
		y_3 += A[6+lda*3] * x_2;
		y_4 += A[6+lda*4] * x_2;
		y_5 += A[6+lda*5] * x_2;
		y_6 += A[6+lda*6] * x_2;
		y_7 += A[6+lda*7] * x_2;

		y_0 += A[7+lda*0] * x_3;
		y_1 += A[7+lda*1] * x_3;
		y_2 += A[7+lda*2] * x_3;
		y_3 += A[7+lda*3] * x_3;
		y_4 += A[7+lda*4] * x_3;
		y_5 += A[7+lda*5] * x_3;
		y_6 += A[7+lda*6] * x_3;
		y_7 += A[7+lda*7] * x_3;
		
		A += sda*bs;
		x += 8;

		}

	x_0 = x[0];
	x_1 = x[1];
	x_2 = x[2];
	x_3 = x[3];
	
	y_0 += A[0+lda*0] * x_0;
	y_1 += A[0+lda*1] * x_0;
	y_2 += A[0+lda*2] * x_0;
	y_3 += A[0+lda*3] * x_0;
	y_4 += A[0+lda*4] * x_0;
	y_5 += A[0+lda*5] * x_0;
	y_6 += A[0+lda*6] * x_0;
	y_7 += A[0+lda*7] * x_0;

/*	y_0 += A[1+lda*0] * x_1;*/
	y_1 += A[1+lda*1] * x_1;
	y_2 += A[1+lda*2] * x_1;
	y_3 += A[1+lda*3] * x_1;
	y_4 += A[1+lda*4] * x_1;
	y_5 += A[1+lda*5] * x_1;
	y_6 += A[1+lda*6] * x_1;
	y_7 += A[1+lda*7] * x_1;
	
/*	y_0 += A[2+lda*0] * x_2;*/
/*	y_1 += A[2+lda*1] * x_2;*/
	y_2 += A[2+lda*2] * x_2;
	y_3 += A[2+lda*3] * x_2;
	y_4 += A[2+lda*4] * x_2;
	y_5 += A[2+lda*5] * x_2;
	y_6 += A[2+lda*6] * x_2;
	y_7 += A[2+lda*7] * x_2;

/*	y_0 += A[3+lda*0] * x_3;*/
/*	y_1 += A[3+lda*1] * x_3;*/
/*	y_2 += A[3+lda*2] * x_3;*/
	y_3 += A[3+lda*3] * x_3;
	y_4 += A[3+lda*4] * x_3;
	y_5 += A[3+lda*5] * x_3;
	y_6 += A[3+lda*6] * x_3;
	y_7 += A[3+lda*7] * x_3;
	
/*	A += sda*bs;*/
/*	x += 4;*/

	x_0 = x[4];
	x_1 = x[5];
	x_2 = x[6];
	x_3 = x[7];
	
/*	y_0 += A[4+lda*0] * x_0;*/
/*	y_1 += A[4+lda*1] * x_0;*/
/*	y_2 += A[4+lda*2] * x_0;*/
/*	y_3 += A[4+lda*3] * x_0;*/
	y_4 += A[4+lda*4] * x_0;
	y_5 += A[4+lda*5] * x_0;
	y_6 += A[4+lda*6] * x_0;
	y_7 += A[4+lda*7] * x_0;

/*	y_0 += A[5+lda*0] * x_1;*/
/*	y_1 += A[5+lda*1] * x_1;*/
/*	y_2 += A[5+lda*2] * x_1;*/
/*	y_3 += A[5+lda*3] * x_1;*/
/*	y_4 += A[5+lda*4] * x_1;*/
	y_5 += A[5+lda*5] * x_1;
	y_6 += A[5+lda*6] * x_1;
	y_7 += A[5+lda*7] * x_1;
	
/*	y_0 += A[6+lda*0] * x_2;*/
/*	y_1 += A[6+lda*1] * x_2;*/
/*	y_2 += A[6+lda*2] * x_2;*/
/*	y_3 += A[6+lda*3] * x_2;*/
/*	y_4 += A[6+lda*4] * x_2;*/
/*	y_5 += A[6+lda*5] * x_2;*/
	y_6 += A[6+lda*6] * x_2;
	y_7 += A[6+lda*7] * x_2;

/*	y_0 += A[7+lda*0] * x_3;*/
/*	y_1 += A[7+lda*1] * x_3;*/
/*	y_2 += A[7+lda*2] * x_3;*/
/*	y_3 += A[7+lda*3] * x_3;*/
/*	y_4 += A[7+lda*4] * x_3;*/
/*	y_5 += A[7+lda*5] * x_3;*/
/*	y_6 += A[7+lda*6] * x_3;*/
	y_7 += A[7+lda*7] * x_3;

	if(alg==0)
		{
		y[0] = y_0;
		y[1] = y_1;
		y[2] = y_2;
		y[3] = y_3;
		y[4] = y_4;
		y[5] = y_5;
		y[6] = y_6;
		y[7] = y_7;
		}
	else if(alg==1)
		{
		y[0] += y_0;
		y[1] += y_1;
		y[2] += y_2;
		y[3] += y_3;
		y[4] += y_4;
		y[5] += y_5;
		y[6] += y_6;
		y[7] += y_7;
		}
	else // alg==-1
		{
		y[0] -= y_0;
		y[1] -= y_1;
		y[2] -= y_2;
		y[3] -= y_3;
		y[4] -= y_4;
		y[5] -= y_5;
		y[6] -= y_6;
		y[7] -= y_7;
		}

	}
	
	
	
void kernel_strmv_u_t_4_lib8(int kmax, float *A, int sda, float *x, float *y, int alg)
	{

/*	if(kmax<=0) */
/*		return;*/
	
	const int lda = 8;
	const int bs  = 8;
	
	int
		k;
	
	float
		x_0, x_1, x_2, x_3,
		y_0=0, y_1=0, y_2=0, y_3=0;
	
	k=0;
	for(; k<kmax-7; k+=8)
		{
		
		x_0 = x[0];
		x_1 = x[1];
		x_2 = x[2];
		x_3 = x[3];
		
		y_0 += A[0+lda*0] * x_0;
		y_1 += A[0+lda*1] * x_0;
		y_2 += A[0+lda*2] * x_0;
		y_3 += A[0+lda*3] * x_0;

		y_0 += A[1+lda*0] * x_1;
		y_1 += A[1+lda*1] * x_1;
		y_2 += A[1+lda*2] * x_1;
		y_3 += A[1+lda*3] * x_1;
		
		y_0 += A[2+lda*0] * x_2;
		y_1 += A[2+lda*1] * x_2;
		y_2 += A[2+lda*2] * x_2;
		y_3 += A[2+lda*3] * x_2;

		y_0 += A[3+lda*0] * x_3;
		y_1 += A[3+lda*1] * x_3;
		y_2 += A[3+lda*2] * x_3;
		y_3 += A[3+lda*3] * x_3;
		
/*		A += sda*bs;*/
/*		x += 4;*/

		x_0 = x[4];
		x_1 = x[5];
		x_2 = x[6];
		x_3 = x[7];
		
		y_0 += A[4+lda*0] * x_0;
		y_1 += A[4+lda*1] * x_0;
		y_2 += A[4+lda*2] * x_0;
		y_3 += A[4+lda*3] * x_0;

		y_0 += A[5+lda*0] * x_1;
		y_1 += A[5+lda*1] * x_1;
		y_2 += A[5+lda*2] * x_1;
		y_3 += A[5+lda*3] * x_1;
		
		y_0 += A[6+lda*0] * x_2;
		y_1 += A[6+lda*1] * x_2;
		y_2 += A[6+lda*2] * x_2;
		y_3 += A[6+lda*3] * x_2;

		y_0 += A[7+lda*0] * x_3;
		y_1 += A[7+lda*1] * x_3;
		y_2 += A[7+lda*2] * x_3;
		y_3 += A[7+lda*3] * x_3;
		
		A += sda*bs;
		x += 8;

		}

	x_0 = x[0];
	x_1 = x[1];
	x_2 = x[2];
	x_3 = x[3];
	
	y_0 += A[0+lda*0] * x_0;
	y_1 += A[0+lda*1] * x_0;
	y_2 += A[0+lda*2] * x_0;
	y_3 += A[0+lda*3] * x_0;

/*	y_0 += A[1+lda*0] * x_1;*/
	y_1 += A[1+lda*1] * x_1;
	y_2 += A[1+lda*2] * x_1;
	y_3 += A[1+lda*3] * x_1;
	
/*	y_0 += A[2+lda*0] * x_2;*/
/*	y_1 += A[2+lda*1] * x_2;*/
	y_2 += A[2+lda*2] * x_2;
	y_3 += A[2+lda*3] * x_2;

/*	y_0 += A[3+lda*0] * x_3;*/
/*	y_1 += A[3+lda*1] * x_3;*/
/*	y_2 += A[3+lda*2] * x_3;*/
	y_3 += A[3+lda*3] * x_3;
	
/*	A += sda*bs;*/
/*	x += 8;*/

	if(alg==0)
		{
		y[0] = y_0;
		y[1] = y_1;
		y[2] = y_2;
		y[3] = y_3;
		}
	else if(alg==1)
		{
		y[0] += y_0;
		y[1] += y_1;
		y[2] += y_2;
		y[3] += y_3;
		}
	else // alg==-1
		{
		y[0] -= y_0;
		y[1] -= y_1;
		y[2] -= y_2;
		y[3] -= y_3;
		}

	}
	
	
	
void kernel_strmv_u_t_2_lib8(int kmax, float *A, int sda, float *x, float *y, int alg)
	{

/*	if(kmax<=0) */
/*		return;*/
	
	const int lda = 8;
	const int bs  = 8;
	
	int
		k;
	
	float
		x_0, x_1, x_2, x_3,
		y_0=0, y_1=0;
	
	k=0;
	for(; k<kmax-7; k+=8)
		{
		
		x_0 = x[0];
		x_1 = x[1];
		x_2 = x[2];
		x_3 = x[3];
		
		y_0 += A[0+lda*0] * x_0;
		y_1 += A[0+lda*1] * x_0;

		y_0 += A[1+lda*0] * x_1;
		y_1 += A[1+lda*1] * x_1;
		
		y_0 += A[2+lda*0] * x_2;
		y_1 += A[2+lda*1] * x_2;

		y_0 += A[3+lda*0] * x_3;
		y_1 += A[3+lda*1] * x_3;
		
/*		A += sda*bs;*/
/*		x += 4;*/

		x_0 = x[4];
		x_1 = x[5];
		x_2 = x[6];
		x_3 = x[7];
		
		y_0 += A[4+lda*0] * x_0;
		y_1 += A[4+lda*1] * x_0;

		y_0 += A[5+lda*0] * x_1;
		y_1 += A[5+lda*1] * x_1;
		
		y_0 += A[6+lda*0] * x_2;
		y_1 += A[6+lda*1] * x_2;

		y_0 += A[7+lda*0] * x_3;
		y_1 += A[7+lda*1] * x_3;
		
		A += sda*bs;
		x += 8;

		}
	for(; k<kmax-3; k+=4)
		{
		
		x_0 = x[0];
		x_1 = x[1];
		x_2 = x[2];
		x_3 = x[3];
		
		y_0 += A[0+lda*0] * x_0;
		y_1 += A[0+lda*1] * x_0;

		y_0 += A[1+lda*0] * x_1;
		y_1 += A[1+lda*1] * x_1;
		
		y_0 += A[2+lda*0] * x_2;
		y_1 += A[2+lda*1] * x_2;

		y_0 += A[3+lda*0] * x_3;
		y_1 += A[3+lda*1] * x_3;
		
/*		A += sda*bs;*/
		A += 4;
		x += 4;

		}

	x_0 = x[0];
	x_1 = x[1];
	
	y_0 += A[0+lda*0] * x_0;
	y_1 += A[0+lda*1] * x_0;

/*	y_0 += A[1+lda*0] * x_1;*/
	y_1 += A[1+lda*1] * x_1;
	
	if(alg==0)
		{
		y[0] = y_0;
		y[1] = y_1;
		}
	else if(alg==1)
		{
		y[0] += y_0;
		y[1] += y_1;
		}
	else // alg==-1
		{
		y[0] -= y_0;
		y[1] -= y_1;
		}

	}
	
	
	
void kernel_strmv_u_t_1_lib8(int kmax, float *A, int sda, float *x, float *y, int alg)
	{

/*	if(kmax<=0) */
/*		return;*/
	
	const int lda = 8;
	const int bs  = 8;
	
	int
		k;
	
	float
		x_0, x_1, x_2, x_3,
		y_0=0;
	
	k=0;
	for(; k<kmax-3; k+=4)
		{
		
		x_0 = x[0];
		x_1 = x[1];
		x_2 = x[2];
		x_3 = x[3];
		
		y_0 += A[0+lda*0] * x_0;
		y_0 += A[1+lda*0] * x_1;
		y_0 += A[2+lda*0] * x_2;
		y_0 += A[3+lda*0] * x_3;
		
		x_0 = x[4];
		x_1 = x[5];
		x_2 = x[6];
		x_3 = x[7];
		
		y_0 += A[4+lda*0] * x_0;
		y_0 += A[5+lda*0] * x_1;
		y_0 += A[6+lda*0] * x_2;
		y_0 += A[7+lda*0] * x_3;
		
		A += sda*bs;
		x += 8;

		}
	for(; k<kmax-1; k+=2)
		{
		
		x_0 = x[0];
		x_1 = x[1];
		
		y_0 += A[0+lda*0] * x_0;
		y_0 += A[1+lda*0] * x_1;
		
		A += 2;
		x += 2;

		}

	x_0 = x[0];
	
	y_0 += A[0+lda*0] * x_0;

	if(alg==0)
		{
		y[0] = y_0;
		}
	else if(alg==1)
		{
		y[0] += y_0;
		}
	else // alg==-1
		{
		y[0] -= y_0;
		}

	}
	
	
	
void kernel_strmv_u_n_8_lib8(int kmax, float *A0, float *x, float *y, int alg)
	{

	if(kmax<=0) 
		return;
	
	const int lda = 8;
	
	int k;

	float
		x_0, x_1, x_2, x_3,
		y_0=0, y_1=0, y_2=0, y_3=0,
		y_4=0, y_5=0, y_6=0, y_7=0;
	
	x_0 = x[0];
	x_1 = x[1];
	x_2 = x[2];
	x_3 = x[3];

	y_0 += A0[0+lda*0] * x_0;
/*	y_1 += A0[1+lda*0] * x_0;*/
/*	y_2 += A0[2+lda*0] * x_0;*/
/*	y_3 += A0[3+lda*0] * x_0;*/
/*	y_4 += A1[0+lda*0] * x_0;*/
/*	y_5 += A1[1+lda*0] * x_0;*/
/*	y_6 += A1[2+lda*0] * x_0;*/
/*	y_7 += A1[3+lda*0] * x_0;*/

	y_0 += A0[0+lda*1] * x_1;
	y_1 += A0[1+lda*1] * x_1;
/*	y_2 += A0[2+lda*1] * x_1;*/
/*	y_3 += A0[3+lda*1] * x_1;*/
/*	y_4 += A1[0+lda*1] * x_1;*/
/*	y_5 += A1[1+lda*1] * x_1;*/
/*	y_6 += A1[2+lda*1] * x_1;*/
/*	y_7 += A1[3+lda*1] * x_1;*/

	y_0 += A0[0+lda*2] * x_2;
	y_1 += A0[1+lda*2] * x_2;
	y_2 += A0[2+lda*2] * x_2;
/*	y_3 += A0[3+lda*2] * x_2;*/
/*	y_4 += A1[0+lda*2] * x_2;*/
/*	y_5 += A1[1+lda*2] * x_2;*/
/*	y_6 += A1[2+lda*2] * x_2;*/
/*	y_7 += A1[3+lda*2] * x_2;*/

	y_0 += A0[0+lda*3] * x_3;
	y_1 += A0[1+lda*3] * x_3;
	y_2 += A0[2+lda*3] * x_3;
	y_3 += A0[3+lda*3] * x_3;
/*	y_4 += A1[0+lda*3] * x_3;*/
/*	y_5 += A1[1+lda*3] * x_3;*/
/*	y_6 += A1[2+lda*3] * x_3;*/
/*	y_7 += A1[3+lda*3] * x_3;*/
	
	A0 += 4*lda;
/*	A1 += 4*lda;*/
	x += 4;

	x_0 = x[0];
	x_1 = x[1];
	x_2 = x[2];
	x_3 = x[3];

	y_0 += A0[0+lda*0] * x_0;
	y_1 += A0[1+lda*0] * x_0;
	y_2 += A0[2+lda*0] * x_0;
	y_3 += A0[3+lda*0] * x_0;
	y_4 += A0[4+lda*0] * x_0;
/*	y_5 += A0[5+lda*0] * x_0;*/
/*	y_6 += A0[6+lda*0] * x_0;*/
/*	y_7 += A0[7+lda*0] * x_0;*/

	y_0 += A0[0+lda*1] * x_1;
	y_1 += A0[1+lda*1] * x_1;
	y_2 += A0[2+lda*1] * x_1;
	y_3 += A0[3+lda*1] * x_1;
	y_4 += A0[4+lda*1] * x_1;
	y_5 += A0[5+lda*1] * x_1;
/*	y_6 += A0[6+lda*1] * x_1;*/
/*	y_7 += A0[7+lda*1] * x_1;*/

	y_0 += A0[0+lda*2] * x_2;
	y_1 += A0[1+lda*2] * x_2;
	y_2 += A0[2+lda*2] * x_2;
	y_3 += A0[3+lda*2] * x_2;
	y_4 += A0[4+lda*2] * x_2;
	y_5 += A0[5+lda*2] * x_2;
	y_6 += A0[6+lda*2] * x_2;
/*	y_7 += A0[7+lda*2] * x_2;*/

	y_0 += A0[0+lda*3] * x_3;
	y_1 += A0[1+lda*3] * x_3;
	y_2 += A0[2+lda*3] * x_3;
	y_3 += A0[3+lda*3] * x_3;
	y_4 += A0[4+lda*3] * x_3;
	y_5 += A0[5+lda*3] * x_3;
	y_6 += A0[6+lda*3] * x_3;
	y_7 += A0[7+lda*3] * x_3;
	
	A0 += 4*lda;
/*	A1 += 4*lda;*/
	x += 4;

	k=8;
	for(; k<kmax-3; k+=4)
		{

		x_0 = x[0];
		x_1 = x[1];
		x_2 = x[2];
		x_3 = x[3];

		y_0 += A0[0+lda*0] * x_0;
		y_1 += A0[1+lda*0] * x_0;
		y_2 += A0[2+lda*0] * x_0;
		y_3 += A0[3+lda*0] * x_0;
		y_4 += A0[4+lda*0] * x_0;
		y_5 += A0[5+lda*0] * x_0;
		y_6 += A0[6+lda*0] * x_0;
		y_7 += A0[7+lda*0] * x_0;

		y_0 += A0[0+lda*1] * x_1;
		y_1 += A0[1+lda*1] * x_1;
		y_2 += A0[2+lda*1] * x_1;
		y_3 += A0[3+lda*1] * x_1;
		y_4 += A0[4+lda*1] * x_1;
		y_5 += A0[5+lda*1] * x_1;
		y_6 += A0[6+lda*1] * x_1;
		y_7 += A0[7+lda*1] * x_1;

		y_0 += A0[0+lda*2] * x_2;
		y_1 += A0[1+lda*2] * x_2;
		y_2 += A0[2+lda*2] * x_2;
		y_3 += A0[3+lda*2] * x_2;
		y_4 += A0[4+lda*2] * x_2;
		y_5 += A0[5+lda*2] * x_2;
		y_6 += A0[6+lda*2] * x_2;
		y_7 += A0[7+lda*2] * x_2;

		y_0 += A0[0+lda*3] * x_3;
		y_1 += A0[1+lda*3] * x_3;
		y_2 += A0[2+lda*3] * x_3;
		y_3 += A0[3+lda*3] * x_3;
		y_4 += A0[4+lda*3] * x_3;
		y_5 += A0[5+lda*3] * x_3;
		y_6 += A0[6+lda*3] * x_3;
		y_7 += A0[7+lda*3] * x_3;
		
		A0 += 4*lda;
/*		A1 += 4*lda;*/
		x += 4;

		}

	for(; k<kmax; k++)
		{

		x_0 = x[0];

		y_0 += A0[0+lda*0] * x_0;
		y_1 += A0[1+lda*0] * x_0;
		y_2 += A0[2+lda*0] * x_0;
		y_3 += A0[3+lda*0] * x_0;
		y_4 += A0[4+lda*0] * x_0;
		y_5 += A0[5+lda*0] * x_0;
		y_6 += A0[6+lda*0] * x_0;
		y_7 += A0[7+lda*0] * x_0;
		
		A0 += 1*lda;
/*		A1 += 1*lda;*/
		x += 1;

		}

	if(alg==0)
		{
		y[0] = y_0;
		y[1] = y_1;
		y[2] = y_2;
		y[3] = y_3;
		y[4] = y_4;
		y[5] = y_5;
		y[6] = y_6;
		y[7] = y_7;
		}
	else if(alg==1)
		{
		y[0] += y_0;
		y[1] += y_1;
		y[2] += y_2;
		y[3] += y_3;
		y[4] += y_4;
		y[5] += y_5;
		y[6] += y_6;
		y[7] += y_7;
		}
	else // alg==-1
		{
		y[0] -= y_0;
		y[1] -= y_1;
		y[2] -= y_2;
		y[3] -= y_3;
		y[4] -= y_4;
		y[5] -= y_5;
		y[6] -= y_6;
		y[7] -= y_7;
		}

	}
	
	
	
void kernel_strmv_u_n_4_lib8(int kmax, float *A, float *x, float *y, int alg)
	{

	if(kmax<=0) 
		return;
	
	const int lda = 8;
	
	int k;

	float
		x_0, x_1, x_2, x_3,
		y_0=0, y_1=0, y_2=0, y_3=0;
	
	x_0 = x[0];
	x_1 = x[1];
	x_2 = x[2];
	x_3 = x[3];

	y_0 += A[0+lda*0] * x_0;
/*	y_1 += A[1+lda*0] * x_0;*/
/*	y_2 += A[2+lda*0] * x_0;*/
/*	y_3 += A[3+lda*0] * x_0;*/

	y_0 += A[0+lda*1] * x_1;
	y_1 += A[1+lda*1] * x_1;
/*	y_2 += A[2+lda*1] * x_1;*/
/*	y_3 += A[3+lda*1] * x_1;*/

	y_0 += A[0+lda*2] * x_2;
	y_1 += A[1+lda*2] * x_2;
	y_2 += A[2+lda*2] * x_2;
/*	y_3 += A[3+lda*2] * x_2;*/

	y_0 += A[0+lda*3] * x_3;
	y_1 += A[1+lda*3] * x_3;
	y_2 += A[2+lda*3] * x_3;
	y_3 += A[3+lda*3] * x_3;
	
	A += 4*lda;
	x += 4;

	k=4;
	for(; k<kmax-3; k+=4)
		{

		x_0 = x[0];
		x_1 = x[1];
		x_2 = x[2];
		x_3 = x[3];

		y_0 += A[0+lda*0] * x_0;
		y_1 += A[1+lda*0] * x_0;
		y_2 += A[2+lda*0] * x_0;
		y_3 += A[3+lda*0] * x_0;

		y_0 += A[0+lda*1] * x_1;
		y_1 += A[1+lda*1] * x_1;
		y_2 += A[2+lda*1] * x_1;
		y_3 += A[3+lda*1] * x_1;

		y_0 += A[0+lda*2] * x_2;
		y_1 += A[1+lda*2] * x_2;
		y_2 += A[2+lda*2] * x_2;
		y_3 += A[3+lda*2] * x_2;

		y_0 += A[0+lda*3] * x_3;
		y_1 += A[1+lda*3] * x_3;
		y_2 += A[2+lda*3] * x_3;
		y_3 += A[3+lda*3] * x_3;
		
		A += 4*lda;
		x += 4;

		}

	for(; k<kmax; k++)
		{

		x_0 = x[0];

		y_0 += A[0+lda*0] * x_0;
		y_1 += A[1+lda*0] * x_0;
		y_2 += A[2+lda*0] * x_0;
		y_3 += A[3+lda*0] * x_0;
		
		A += 1*lda;
		x += 1;

		}

	if(alg==0)
		{
		y[0] = y_0;
		y[1] = y_1;
		y[2] = y_2;
		y[3] = y_3;
		}
	else if(alg==1)
		{
		y[0] += y_0;
		y[1] += y_1;
		y[2] += y_2;
		y[3] += y_3;
		}
	else // alg==-1
		{
		y[0] -= y_0;
		y[1] -= y_1;
		y[2] -= y_2;
		y[3] -= y_3;
		}

	}
	
	
	
void kernel_strmv_u_n_2_lib8(int kmax, float *A, float *x, float *y, int alg)
	{

	if(kmax<=0) 
		return;
	
	const int lda = 8;
	
	int k;

	float
		x_0, x_1, x_2, x_3,
		y_0=0, y_1=0;
	
	x_0 = x[0];
	x_1 = x[1];

	y_0 += A[0+lda*0] * x_0;
/*	y_1 += A[1+lda*0] * x_0;*/

	y_0 += A[0+lda*1] * x_1;
	y_1 += A[1+lda*1] * x_1;
	
	A += 2*lda;
	x += 2;

	k=2;
	for(; k<kmax-3; k+=4)
		{

		x_0 = x[0];
		x_1 = x[1];
		x_2 = x[2];
		x_3 = x[3];

		y_0 += A[0+lda*0] * x_0;
		y_1 += A[1+lda*0] * x_0;

		y_0 += A[0+lda*1] * x_1;
		y_1 += A[1+lda*1] * x_1;

		y_0 += A[0+lda*2] * x_2;
		y_1 += A[1+lda*2] * x_2;

		y_0 += A[0+lda*3] * x_3;
		y_1 += A[1+lda*3] * x_3;
		
		A += 4*lda;
		x += 4;

		}

	for(; k<kmax; k++)
		{

		x_0 = x[0];

		y_0 += A[0+lda*0] * x_0;
		y_1 += A[1+lda*0] * x_0;
		
		A += 1*lda;
		x += 1;

		}

	if(alg==0)
		{
		y[0] = y_0;
		y[1] = y_1;
		}
	else if(alg==1)
		{
		y[0] += y_0;
		y[1] += y_1;
		}
	else // alg==-1
		{
		y[0] -= y_0;
		y[1] -= y_1;
		}

	}
	
	
	

