/*
 *	This file is part of qpDUNES.
 *
 *	qpDUNES -- A DUal NEwton Strategy for convex quadratic programming.
 *	Copyright (C) 2012 by Janick Frasch, Hans Joachim Ferreau et al.
 *	All rights reserved.
 *
 *	qpDUNES is free software; you can redistribute it and/or
 *	modify it under the terms of the GNU Lesser General Public
 *	License as published by the Free Software Foundation; either
 *	version 2.1 of the License, or (at your option) any later version.
 *
 *	qpDUNES is distributed in the hope that it will be useful,
 *	but WITHOUT ANY WARRANTY; without even the implied warranty of
 *	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 *	See the GNU Lesser General Public License for more details.
 *
 *	You should have received a copy of the GNU Lesser General Public
 *	License along with qpDUNES; if not, write to the Free Software
 *	Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA
 *
 */


/**
 *	\file include/qp/qpDimensions.h
 *	\author Janick Frasch
 *	\version 1.0beta
 *	\date 2014
 *
 *	Definition of QP dimensions. This is only required when the static memory version of qpDUNES is used.
 *
 *	This file may be automatically generated by code export.
 *
 */


#ifndef QPDIMENSIONS_H_
#define QPDIMENSIONS_H_

#assert defined(__STATIC_MEMORY__)


/* Define the QP problem's dimensions below */
#define _NX_ 3				/* the number of states */
#define _NU_ 1				/* the number of controls */
#define _NZ_ (_NX_+_NU_)	/* the number of stage variables */
#define _NI_ 10				/* the number of control intervals */
#define _NDMAX_ 10			/* the maximum number of affine stage constraints over all stages */
#define _NDTTL_ 100			/* the total number of affine stage constraints summed over all stages */


#endif /* QPDIMENSIONS_H_ */
