/*
 *	This file is part of qpDUNES.
 *
 *	qpDUNES -- A DUal NEwton Strategy for convex quadratic programming.
 *	Copyright (C) 2012 by Janick Frasch, Hans Joachim Ferreau et al. 
 *	All rights reserved.
 *
 *	qpDUNES is free software; you can redistribute it and/or
 *	modify it under the terms of the GNU Lesser General Public
 *	License as published by the Free Software Foundation; either
 *	version 2.1 of the License, or (at your option) any later version.
 *
 *	qpDUNES is distributed in the hope that it will be useful,
 *	but WITHOUT ANY WARRANTY; without even the implied warranty of
 *	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 *	See the GNU Lesser General Public License for more details.
 *
 *	You should have received a copy of the GNU Lesser General Public
 *	License along with qp42; if not, write to the Free Software
 *	Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA
 *
 */


/**
 *	\file include/qpDUNES.h
 *	\author Janick Frasch, Hans Joachim Ferreau
 *	\version 1.0beta
 *	\date 2012
 */


#include "qp/types.h"
#include "qp/matrix_vector.h"
#include "qp/stage_qp_solver_clipping.h"
#include "qp/stage_qp_solver_qpoases.hpp"
#include "qp/dual_qp.h"
#include "qp/qpdunes_utils.h"

#ifdef __cplusplus
extern "C"
{
#endif /* __cplusplus */

#include "qp/types.h"
#if !defined(__STATIC_MEMORY__)
	#include "qp/qpData.h"
#else
	#include "qp/qpDataStatic.h"
#endif
#include "qp/matrix_vector.h"
#include "qp/stage_qp_solver_clipping.h"

#include "qp/dual_qp.h"
#include "qp/qpdunes_utils.h"


#ifdef __cplusplus
}
#endif /* __cplusplus */

#include "qp/stage_qp_solver_qpoases.hpp"




/*
 *	end of file
 */
